; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 656
WINDOWHEIGHT = 518
MATRIX struct; A Structure to Hold An OpenGL Matrix 
	Data_ dd 16 dup(?); we Use [16] Due to OpenGL's Matrix Format 
MATRIX ends
VECTOR	struct; A Structure to Hold A Single vector 
	X dd ?
	Y dd ?
	Z dd ?; the Components of the vector 
VECTOR	ends
VERTEX struct; A Structure to Hold A Single Vertex 
	Nor VECTOR <>; Vertex Normal 
	Pos VECTOR <>; Vertex Position 
VERTEX ends
POLYGON	struct; A Structure to Hold A Single Polygon 
	Verts VERTEX 3 dup (<>); Array of 3 VERTEX Structures 
POLYGON ends;
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	TmpMatrix:MATRIX; Temporary MATRIX Structure 
local	TmpVector:VECTOR 
local	TmpNormal:VECTOR; Temporary VECTOR Structures 
local	TmpShade:dword; Temporary Shader Value
local	hFile:qword
local	szReadWrite:dword	;number of bytes actually read or write
local	temp:dword

        mov	hWin,rcx
        xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN
        cmp	edx,WM_TIMER
	je      wmTIMER
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	invoke	KillTimer,hWin,10
	mov	edx,offset shaderTexture
	invoke	glDeleteTextures,1; Delete the Shader Texture 
	mov	ecx,polyData
	invoke	GlobalFree; Delete the Polygon Data 
	invoke	RtlExitUserProcess,NULL
;----------------------------------------------
wmTIMER:cmp	modelRotate,0
	jz      wmBYE; Check to See If Rotation Is Enabled 
	cvtsi2ss xmm0,milliseconds
	mulss	xmm0,const0_1
	addss	xmm0,modelAngle
	movss	modelAngle,xmm0;modelAngle += (float) (milliseconds) / 10.0f; Update Angle Based On the Clock
	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	cmp	al,VK_SPACE
	jne	@f
	xor	modelRotate,1
	jmp	@0
@@:    	cmp	al,VK_1
	jne	@f
	xor	outlineDraw,1
	jmp	@0
@@:    	cmp	al,VK_2
	jne	@f
	xor	outlineSmooth,1
	jmp	@0
@@:    	cmp	al,VK_UP
	jne	@f
	movss	xmm0,outlineWidth
	addss	xmm0,const1
	movss	outlineWidth,xmm0
	jmp	@0
@@:    	cmp	al,VK_DOWN
	jne	wmBYE
	movss	xmm0,outlineWidth
	subss	xmm0,const1
	movss	outlineWidth,xmm0
@0:	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	mov	r8d,milliseconds
	invoke	SetTimer,hWin,10,,0;  #10  25mSec
;-------------------------------------------------------
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST;// Realy Nice perspective calculations
	xorps	xmm3,xmm3
	movss	xmm2,const0_7
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glClearColor;0.7, 0.7, 0.7, 0	 Light Grey Background
	cvtss2sd xmm0,const1
	invoke	glClearDepth;1.0	Depth Buffer Setup

	invoke	glEnable,GL_DEPTH_TEST;// Enable Depth Testing
	invoke	glDepthFunc,GL_LESS;	// the Type of Depth Test to Do

	invoke	glShadeModel,GL_SMOOTH;// Enables Smooth Color Shading 
	invoke	glDisable,GL_LINE_SMOOTH;// Initially Disable Line Smoothing 

	invoke	glEnable,GL_CULL_FACE;// Enable OpenGL Face Culling 

	invoke	glDisable,GL_LIGHTING;// Disable OpenGL Lighting 

	mov	edx,offset shaderTexture
	invoke	glGenTextures,1; Get A Free Texture ID 
	mov	edx,shaderTexture
	invoke	glBindTexture,GL_TEXTURE_1D; Bind This Texture. From Now On It Will Be 1D 

; For Crying Out Loud don't Let OpenGL Use Bi/Trilinear Filtering! 
	invoke	glTexParameteri,GL_TEXTURE_1D, GL_TEXTURE_MAG_FILTER, GL_NEAREST;	
	invoke	glTexParameteri,GL_TEXTURE_1D, GL_TEXTURE_MIN_FILTER, GL_NEAREST;
	xor	edx,edx
	mov	r8d,GL_RGB
	mov	r9d,32
	mov	[rsp+20h],rdx
	mov	[rsp+28h],r8
	mov	qword ptr [rsp+30h],GL_FLOAT
	movr	qword ptr [rsp+38h],shaderData
	invoke	glTexImage1D,GL_TEXTURE_1D;	// Upload 

	mov	ecx,offset lightAngle
	invoke	Normalize; Normalize the Light Direction 
; Reads the Contents of the "model.txt" File 
	mov	ecx,offset FileName1;Model.txt   88132
	invoke	CreateFile,,GENERIC_READ,0,0,OPEN_EXISTING,\
	FILE_ATTRIBUTE_ARCHIVE,0
        mov	hFile,rax
	lea	r9d,szReadWrite
	mov	edx,offset polyNum;4C8=1224
        invoke	ReadFile,eax,,4,,rbx
        imul	edx,polyNum,sizeof POLYGON
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED
	mov	polyData,eax
	lea	r9d,szReadWrite
	imul	r8d,polyNum,sizeof POLYGON;1224*72=88124
        invoke	ReadFile,hFile,eax,,,rbx
        invoke	CloseHandle,hFile           

        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
; --------------- Display the scene
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT;		// Clear the Buffers
	invoke	glLoadIdentity ; Reset the Matrix
	cmp	outlineSmooth,0; Check to See If we Want Anti-Aliased Lines 
	jz	@f
	invoke	glHint,GL_LINE_SMOOTH_HINT, GL_NICEST; Use the Good Calculations 
	invoke	glEnable,GL_LINE_SMOOTH; Enable Anti-Aliasing 
	jmp	@1
; we don't Want Smooth Lines 
@@:	invoke	glDisable,GL_LINE_SMOOTH; Disable Anti-Aliasing 
@1:	movss	xmm2,const_2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;0, 0, -2.0	 Move 2 Units Away From the Screen 
	xorps	xmm3,xmm3
	movss	xmm2,const1
	xorps	xmm1,xmm1
	movss	xmm0,modelAngle
	invoke	glRotatef;modelAngle, 0, 1, 0		// Rotate the Model On It's Y-Axis 
	lea	edx,TmpMatrix
	invoke	glGetFloatv,GL_MODELVIEW_MATRIX; Get the Generated Matrix 

; Cel-Shading Code 
	invoke	glEnable,GL_TEXTURE_1D;// Enable 1D Texturing 
	mov	edx,shaderTexture
	invoke	glBindTexture,GL_TEXTURE_1D; Bind Our Texture 

	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glColor3f;1, 1, 1		set the Color of the Model 

	invoke	glBegin,GL_TRIANGLES; tell OpenGL That we're Drawing Triangles
	imul	eax,polyNum,sizeof POLYGON;72
	mov	temp,eax
	xor	esi,esi;Loop Through Each Polygon 
@2:	xor	edi,edi;Loop Through Each Vertex 
@3:	mov	eax,polyData
	add	eax,esi
	mov	ecx,[rax+rdi].VERTEX.Nor.X
	mov	TmpNormal.X,ecx;TmpNormal.X = polyData[i].Verts[j].Nor.X; Fill Up the TmpNormal Structure With
	mov	ecx,[rax+rdi].VERTEX.Nor.Y
	mov	TmpNormal.Y,ecx;TmpNormal.Y = polyData[i].Verts[j].Nor.Y; the Current Vertices' Normal Values 
	mov	ecx,[rax+rdi].VERTEX.Nor.Z
	mov	TmpNormal.Z,ecx;TmpNormal.Z = polyData[i].Verts[j].Nor.Z;

	lea	ecx,TmpMatrix
	lea	edx,TmpNormal
	lea	r8d,TmpVector
	invoke	RotateVector; Rotate This by the Matrix 
	lea	ecx,TmpVector
	invoke	Normalize; Normalize the New Normal 
	mov	edx,offset lightAngle
	lea	ecx,TmpVector
	invoke	DotProduct; calculate the Shade Value 
	movss	TmpShade,xmm0
	xorps	xmm1,xmm1
	comiss	xmm0,xmm1
	jnl	@f;	if (TmpShade < 0.0f)
	movss	TmpShade,xmm1; Clamp the Value to 0 If Negative 
@@:	invoke	glTexCoord1f; set the Texture Co-ordinate As the Shade Value 
	mov	ecx,esi
	add	ecx,polyData
	lea	ecx,[rcx+rdi].VERTEX.Pos.X
	invoke	glVertex3fv;&polyData[i].Verts[j].Pos.X; Send the Vertex Position 
	add	edi,sizeof VERTEX;24
	cmp	edi,sizeof POLYGON;3*24
	jb	@3
	add	esi,edi;72
	cmp	esi,temp
	jb	@2

	invoke	glEnd ; tell OpenGL to Finish Drawing
	invoke	glDisable,GL_TEXTURE_1D; Disable 1D Textures 
; Outline Code 
	cmp	outlineDraw,0; Check to See If we Want to Draw the Outline 
	jz	@4
	invoke	glEnable,GL_BLEND; Enable Blending 
	invoke	glBlendFunc,GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA; set the Blend Mode 

	invoke	glPolygonMode,GL_BACK, GL_LINE; Draw Backfacing Polygons As Wireframes 
	movss	xmm0,outlineWidth
	invoke	glLineWidth; set the Line Width 

	invoke	glCullFace,GL_FRONT; don't Draw Any Front-Facing Polygons 

	invoke	glDepthFunc,GL_LEQUAL; Change the Depth Mode 
	mov	ecx,offset outlineColor
	invoke	glColor3fv; set the Outline Color 

	invoke	glBegin,GL_TRIANGLES; tell OpenGL what we Want to Draw
;
	xor	esi,esi; Loop Through Each Polygon 
@5:	xor	edi,edi; Loop Through Each Vertex 
@6:	mov	ecx,esi
	add	ecx,polyData
	lea	ecx,[rcx+rdi].VERTEX.Pos.X
	invoke	glVertex3fv;,&polyData[i].Verts[j].Pos.X;	// Send the Vertex Position 
	add	edi,sizeof VERTEX;24
	cmp	edi,sizeof POLYGON;3*24
	jb	@6
	add	esi,edi;72
	cmp	esi,temp
	jb	@5
	invoke	glEnd ; tell OpenGL we've Finished
	invoke	glDepthFunc,GL_LESS; Reset the Depth-Testing Mode 
	invoke	glCullFace,GL_BACK; Reset the Face to Be Culled 
	invoke	glPolygonMode,GL_BACK, GL_FILL; Reset Back-Facing Polygon Drawing Mode 
	invoke	glDisable,GL_BLEND; Disable Blending
;   
@4:	invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
;// Math Functions
DotProduct proc V1:dword, V2:dword; calculate the Angle Between the 2 vectors 
	movups	xmm0,[rcx]
	mulps	xmm0,[rdx]
	movups	xmm1,xmm0
	shufps	xmm1,xmm1,4Eh
	addps	xmm0,xmm1
	movups	xmm1,xmm0
	shufps	xmm1,xmm1,11h
	addps	xmm0,xmm1;xmm0=V1.X * V2.X + V1.Y * V2.Y + V1.Z * V2.Z	// return the Angle 
	leave
	ret
DotProduct endp

Normalize proc V:dword; Creates A vector With A Unit length of 1 
;Magnitude
	movups	xmm0,[rcx]
	mulps	xmm0,xmm0
	movups	xmm1,xmm0
	shufps	xmm1,xmm1,4Eh
	addps	xmm0,xmm1
	movups	xmm1,xmm0
	shufps	xmm1,xmm1,11h
	addps	xmm0,xmm1;xmm0=V.X * V.X + V.Y * V.Y + V.Z * V.Z	// return the Angle 
	sqrtps	xmm0,xmm0;xmm0=sqrt(xmm0)	return the length of the vector 
	xorps	xmm1,xmm1
	comiss	xmm0,xmm1
	jz	@f;make sure we don't divide by 0 
	movups	xmm1,[rcx]; calculate the length of the vector  
	divps	xmm1,xmm0
	movups	[rcx],xmm1
@@:	leave
	ret
Normalize endp

RotateVector proc M:dword,V:dword,D:dword;(MATRIX &M, VECTOR &V, VECTOR &D)				// Rotate A vector Using the Supplied Matrix 
	movss	xmm0,dword ptr [rcx+0*4]
	mulss	xmm0,[rdx].VECTOR.X
	movss	xmm1,dword ptr [rcx+4*4]
	mulss	xmm1,[rdx].VECTOR.Y
	addss	xmm0,xmm1
	movss	xmm2,dword ptr [rcx+8*4]
	mulss	xmm2,[rdx].VECTOR.Z
	addss	xmm0,xmm2
	movss	[r8].VECTOR.X,xmm0;D.X = (M.Data[0] * V.X) + (M.Data[4] * V.Y) + (M.Data[8]  * V.Z);	// Rotate Around the X Axis 
	movss	xmm0,dword ptr [rcx+1*4]
	mulss	xmm0,[rdx].VECTOR.X
	movss	xmm1,dword ptr [rcx+5*4]
	mulss	xmm1,[rdx].VECTOR.Y
	addss	xmm0,xmm1
	movss	xmm2,dword ptr [rcx+9*4]
	mulss	xmm2,[rdx].VECTOR.Z
	addss	xmm0,xmm2
	movss	[r8].VECTOR.Y,xmm0;D.Y = (M.Data[1] * V.X) + (M.Data[5] * V.Y) + (M.Data[9]  * V.Z);	// Rotate Around the Y Axis 
	movss	xmm0,dword ptr [rcx+2*4]
	mulss	xmm0,[rdx].VECTOR.X
	movss	xmm1,dword ptr [rcx+6*4]
	mulss	xmm1,[rdx].VECTOR.Y
	addss	xmm0,xmm1
	movss	xmm2,dword ptr [rcx+10*4]
	mulss	xmm2,[rdx].VECTOR.Z
	addss	xmm0,xmm2
	movss	[r8].VECTOR.Z,xmm0;D.Z = (M.Data[2] * V.X) + (M.Data[6] * V.Y) + (M.Data[10] * V.Z);	// Rotate Around the Z Axis 
	leave
	ret
RotateVector endp
;---------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson #37 - Cel-Shading Tutorial",0
FileName	db "br_Rabbit3.cur",0
FileName1	db "Model.txt",0
; User Defined Variables
outlineDraw	db TRUE; Flag to Draw the Outline 
outlineSmooth	db FALSE; Flag to Anti-Alias the Lines 
outlineColor	dd 0, 0, 0; Color of the Lines 
outlineWidth	dd 3.0; Width of the Lines 

lightRotate	db FALSE; Flag to See If we Rotate the Light 

modelAngle	dd 0; Y-Axis Angle of the Model 
modelRotate	db FALSE; Flag to Rotate the Model 

polyData	dd ?; Polygon Data 
polyNum		dd 0; Number of Polygons 
shaderTexture	dd ?; Storage For One Texture 
milliseconds	dd 25
shaderData	dd 12 dup(0.2),30 dup(0.5),54 dup(1.0)
;-----------------------------
;float
const0_1	dd 0.1
const0_7	dd 0.7
const1		dd 1.0
const_2		dd -2.0
;double
constd0_1	dq 0.1
constd45	dq 45.0
constd100	dq 100.0
align 16
lightAngle	VECTOR <0,0,1.0>; the Direction of the Light 
dd 0
end